// Bericht Kalender ein Monat
// nachbearbeiteter Code
// s.a. 2024-08-15
using craftsReport.Interfaces;

namespace craftsReport.modules
{
	public class rkalmo_xbs : IReportModule
	{
		public IReportHost HostObject { set; get; }

		public rkalmo_xbs()
		{
		}


		// Kalender_monatlich
		public bool Execute()
		{

			// -------------------------------------------------------------------------
			//  Variablen:
			//  Zeile     aktuelle Zeilenummer
			//  ZlMax     Zeile ab der der Fussbereich beginnt
			//  Seite     Seitennummer beginnend mit 1
			//  RandX     linker Rand in cm
			//  RandY     oberer Rand in cm
			//  SizeX     Druckbreite ab Rand links
			//  recMAIN   Datensatz fuer Main-Schleifen
			// --------------------------------------------------------------------------
			// ==== Test auf Existenz und Belegung der variablen Heute
			if (HostObject.IsVar("Heute"))
				goto HeuteIsSet;
			HostObject.DefineVariable2("Heute", "D,10,0");
			HostObject.Set("Heute", @"H", true);
			HeuteIsSet:

			HostObject.DefineVariable2("RepTitel", "C,50,0");
			HostObject.DefineVariable2("Zeile", "s,2,0");
			HostObject.DefineVariable2("ZlMax", "s,2,0");
			HostObject.DefineVariable2("Seite", "s,2,0");
			HostObject.DefineVariable2("RandX", "d,8,2");
			HostObject.DefineVariable2("RandY", "d,8,2");
			HostObject.DefineVariable2("SizeX", "d,8,2");
			HostObject.DefineVariable2("cyZeile", "d,8,3");

			HostObject.DefineVariable2("mTagMon", "C,5,0");
			HostObject.Set("mTagMon", @"$[Heute<5]", true);

			HostObject.Set("RepTitel", @"Kalender $[mTagMon>2]/$[Heute>4]", true);
			HostObject.Set("RandX", @"      1,80", true);
			HostObject.Set("RandY", @"      0,80", true);
			HostObject.Set("SizeX", @"      18,0", true);
			HostObject.Set("Seite", @"      1", true);
			HostObject.Set("Zeile", @"      0", true);
			//  8 Lines Per Inc
			HostObject.Set("cyZeile", @"    2.54/5.7", true);
			HostObject.Set("ZlMax", @"     60", true);

			//  Datensatz EIGENE_ANSCHRIFTEN
			HostObject.DefineRecord("recADR", "EIGENE_ANSCHRIFTEN", 0, 2, HostObject.EvalString(@"01"));

			// -------------------------------------------------------------------------
			//  TODO 
			//  Fügen Sie hier den Code für die Initialisierung
			//  des Berichts ein.



			//  Code für den
			//  Berichtsablauf ein.

			//  TODO 
			//  fügen Sie hier eine Datensatzvariable
			//  mit dem Namen recMAIN ein.
			//  Diese Variable beinhaltet die Leittabelle.
			HostObject.DefineRecord("recMAIN", "VIRTUELLES_DATUM", 1, 0, HostObject.EvalString(@""));
			HostObject.FindRecord("recMAIN", HostObject.EvalString("$[Heute>4]$[mTagMon>2]"));

			// -----------------------------------------------------------------------------
			//  Vorbereiten der Ausgabe 
			//  Initialisierung der Drucksteuerdaten
			HostObject.WriteLine(HostObject.EvalString(@"INITPAGESIZE"));
			HostObject.WriteLine(HostObject.EvalString(@"STARTJOB $[RepTitel]"));
			HostObject.WriteLine(HostObject.EvalString(@"TRANSPARENT"));
			HostObject.WriteLine(HostObject.EvalString(@"STARTPAGE"));
			HostObject.Set("Zeile", @"0", true);
			HostObject.ProcessResource("KopfBericht");
			HostObject.ProcessResource("KopfDetail");
			// -----------------------------------------------------------------------------

			//  Aufruf des Unterprogramms loopMAIN fuer jeden Datensatz
			//  der an recMAIN gebundenen Tabelle
			while(!HostObject.TestEof("recMAIN"))
			{
				SUB_loopMAIN();
				HostObject.SkipRecord("recMAIN");
			}

			//  ----------------------------------------------------
			//  Druckdatei abschliessen
			HostObject.Set("Zeile", @"$[ZlMax]", true);
			HostObject.ProcessResource("FussBericht");
			HostObject.ProcessResource("outPost");
			HostObject.WriteLine(HostObject.EvalString(@"ENDPAGE"));
			HostObject.WriteLine(HostObject.EvalString(@"ENDJOB"));


			return true;
		}


		bool SUB_Kopf()
		{
			HostObject.VariablesPush();

			//  Dieser Code wird immer beim Seitenwchsel
			//  aufgerufen, um den Kopf der nächsten Seite
			//  auszugeben
			//  Der Kopf für die erste Seite steht jedoch
			//  im Codestück OnPreReport

			HostObject.Set("Zeile", @"0", true);
			HostObject.ProcessResource("KopfSeite");
			HostObject.ProcessResource("KopfDetail");

			return HostObject.VariablesPop();
		}


		bool SUB_Fuss()
		{
			HostObject.VariablesPush();

			//  Dieser Code wird immer beim Seitenwchsel
			//  aufgerufen, um den Fuss der aktuellen Seite
			//  auszugeben
			//  Der Fuss für die letzte Seite steht jedoch
			//  im Codestück OnPostReport

			HostObject.Set("Zeile", @"$[ZlMax]", true);
			HostObject.ProcessResource("FussSeite");
			HostObject.ProcessResource("outPost");
			HostObject.WriteLine(HostObject.EvalString(@"ENDPAGE"));
			HostObject.Set("Seite", @"$[Seite]+1", true);
			HostObject.Set("Zeile", @"0", true);
			HostObject.WriteLine(HostObject.EvalString(@"STARTPAGE"));

			return HostObject.VariablesPop();
		}


		bool SUB_CheckPage()
		{
			HostObject.VariablesPush();

			//  Fussbereich ausgeben, wenn letzte Zeile erreicht
			if (HostObject.EvalBool("$[Zeile] >= $[ZlMax]"))
				SUB_Fuss();
			//  Kopfbereich ausgeben, wenn erste Zeile erreicht
			if (HostObject.EvalBool("$[Zeile] = 0"))
				SUB_Kopf();

			return HostObject.VariablesPop();
		}


		bool SUB_NeueSeite()
		{
			HostObject.VariablesPush();

			//  nächste Seite anfangen
			SUB_Fuss();
			SUB_Kopf();

			return HostObject.VariablesPop();
		}


		bool SUB_loopMAIN()
		{
			HostObject.VariablesPush();

			//  Unterprogramm von ReportMain
			//  Datensatzschleife recMAIN

			if (HostObject.EvalBool(" $[mTagMon>2] <> $[recMAIN.Monat] "))
				goto Exit;

			//  Montag bis Freitag
			if (HostObject.EvalBool(" 5 > $[recMAIN.NWochentag] "))
				goto Werktag;

			if (HostObject.EvalBool(" 5 = $[recMAIN.NWochentag] "))
				goto Samstag;

			if (HostObject.EvalBool(" 6 = $[recMAIN.NWochentag] "))
				goto Sonntag;

			Werktag:
			HostObject.ProcessResource("outMAIN");
			HostObject.ProcessResource("outLine");
			return HostObject.VariablesPop();

			Samstag:
			return HostObject.VariablesPop();

			Sonntag:
			HostObject.ProcessResource("outLineFeed");
			HostObject.ProcessResource("outLine");
			return HostObject.VariablesPop();

			Exit:
			HostObject.BreakRecord("recMAIN");
			return HostObject.VariablesPop();
		}
	}
}
